//+------------------------------------------------------------------+
//|                                     Bullish Reversal+LTL+EMA.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                             Bullish Reversal.mq4 |
//|                                                               ar |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//       .    -   - 
//        -      .   
//  0,1     3     0,1  8600 28.06 -    
//         17   -   = 3  7494  4     
#property copyright "ar"
#property link      "http://www.metaquotes.net"

extern double Lots=0.51;
extern double StopLoss=0;
extern double TakeProfit=1400;
extern double TrailingStop=50;
extern int    UseTrailingStop=1;
int ThisBarTrade=0;
//--------------------------------------------------------------------------------+                                          
#define MAGIC  1234
#define IDENT  "mo_bidir_v0_1"

extern double  lots           = 0.70;
extern double  stop_loss      = 8600;   // (8 pips) optimise 50-2000
extern double  take_profit    = 1410;  // (75 pips) optimise 50-2000

int            last_bar       = 0;
//--------------------------------------------------------------------
extern int     period_EMA           = 50,
               period_WMA           = 28 ,
               period_RSI           = 14,
               stoploss             = 0,
               takeprofit           = 320,
               risk                 = 10,
               Magic                = 777;
extern bool    CloseCounter         = false;
extern double  Lot                  = 0.10;
extern int     _TrailingStop         = 00;    //= 0,      
extern int     Tip_Fr_or_Candl      = 0;     //= 0,     
                                             //= 1,    
extern double MaxRisk=0.4;               //      
extern int     Step                 = 50;       //  d
 //------------------------------------------------------------------------------------------
extern int N        = 12;   //      
extern int TF       = 3;    //0= ,1=1,2=5,3=15,4=30,5=1,6=4,7=D1,8=W1,9=MN.
extern int Distance = 3;    //     
//------------------------------------------------------------------------------------------
double StopUp,StopDn,Tick;
int mper[10]={0,1,5,15,30,60,240,1440,10080,43200};
int q = 1;
                                            
//--------------------------------------------------------------------
double SL,TP,LOT;
int TimeBar;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---

if(Digits==3 || Digits==5) q=10;
Distance = Distance * q;
Tick = MarketInfo(Symbol(), MODE_TICKSIZE);

  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
   if (last_bar == Bars) return(0);
   last_bar = Bars;
   if (OrdersTotal() == 0){
         OrderSend(Symbol(), OP_BUY, lots ,Ask, 3, Ask - stop_loss * Point, Bid + take_profit * Point, IDENT, MAGIC, 0, Blue);
         OrderSend(Symbol(), OP_SELL, lots ,Bid, 3, Bid + stop_loss * Point, Ask - take_profit * Point, IDENT, MAGIC, 0, Red);
   }
   StopUp = iLow(Symbol(),mper[TF],iLowest(Symbol(),mper[TF],MODE_LOW,N,1));
   StopDn = iHigh(Symbol(),mper[TF],iHighest(Symbol(),mper[TF],MODE_HIGH,N,1));
  
   for(int i=0;i<OrdersTotal();i++){if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
   if (OrderSymbol()==Symbol()){
   TrailingStop();}}}


//  ,  %  
double Free =AccountFreeMargin();
double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
double Min_Lot =MarketInfo(Symbol(),MODE_MINLOT);
double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);
double Step =MarketInfo(Symbol(),MODE_LOTSTEP);
double Lot =MathFloor(Free*MaxRisk/100/One_Lot/Step)*Step;
if(Lot<Min_Lot) Lot=Min_Lot;
if(Lot>Max_Lot) Lot=Max_Lot;


   if (TimeBar==Time[0]) return(0);
   double EMA0 = iMA(NULL,0,period_EMA,0,MODE_EMA, PRICE_OPEN,0);
   double WMA0 = iMA(NULL,0,period_WMA,0,MODE_LWMA,PRICE_OPEN,0);
   double EMA1 = iMA(NULL,0,period_EMA,0,MODE_EMA, PRICE_OPEN,1);
   double WMA1 = iMA(NULL,0,period_WMA,0,MODE_LWMA,PRICE_OPEN,1);
   double RSI  = iRSI(NULL,0,period_RSI,PRICE_OPEN,0);
   if (EMA0 < WMA0 && EMA1 > WMA1 && RSI > 50)
   {
      TimeBar=Time[0];                            
      if (takeprofit!=0) TP  = Ask + takeprofit*Point;
      if (stoploss!=0)   SL  = Ask - stoploss*  Point;     
      LOT = LOT(risk,1);
      if (CloseCounter) CLOSEORDER("Sell");
      OPENORDER ("Buy");
   }
   if (EMA0 > WMA0 && EMA1 < WMA1 && RSI < 50)
   {
      TimeBar=Time[0];                            
      if (takeprofit!=0) TP = Bid - takeprofit*Point;
      if (stoploss!=0)   SL = Bid + stoploss*  Point;            
      LOT = LOT(risk,1);
      if (CloseCounter) CLOSEORDER("Buy");
      OPENORDER ("Buy");
   }
   TrailingStop();       
//----
// int quick variables
   int ticket,total;
// check sample size  
if(Bars<50)
   {
    Print("Sample Size Too Small");
    return(0);
    }
if(OrdersTotal()<1) // check if there are any postions open
   {
   if (Bars != ThisBarTrade )
    {
      ThisBarTrade = Bars;  // ensure only one trade opportunity per bar
  
     if(AccountFreeMargin()<1000*Lots) // check margin level
        {
          Print("Free Margin = ",AccountFreeMargin());
         return(0);
         }
// seting up quick variables for candle stick parts
double high1=iHigh(NULL,0,1);
double close1=iClose(NULL,0,1);
double open1=iOpen(NULL,0,1);
double low1=iLow(NULL,0,1);
double high2=iHigh(NULL,0,2);
double close2=iClose(NULL,0,2);
double open2=iOpen(NULL,01,2);
double low2=iLow(NULL,0,2);
double high3=iHigh(NULL,0,3);
double close3=iClose(NULL,0,3);
double open3=iOpen(NULL,0,3);
double low3=iLow(NULL,01,3);
double MA=iMA(NULL,0,50,0,MODE_SMA,PRICE_CLOSE,0);
// set up partern names
// strong Indicator
bool abandoned_baby=((open3>close3)&&(open2>close2)&&(low2<low3)&&(open1<close1)&&(low1>=low2)&&(close1>open3));
bool morning_doji_star=((open3>close3)&&((open2-close2)<=0)&&(open1<close3)&&(close1<open3));
bool three_inside_up=((open3>close3)&&(MathAbs(close2-open2))<=0.6*MathAbs(open3-close3)&&(close2>open2)&&(close1>open1)&&(close1>open3));
bool three_outside_up=((open3>close3)&&(1.1*MathAbs(open3-close3)<MathAbs(open2-close2))&&(open2<close2)&&(open1<close1));
bool three_white_soldiers=((open3<close3)&&(open2<close2)&&(open1<close1)&&(close3<close2<close1));
//----
bool hammer=((MathAbs(low1-MathMin(open1,close1))>=2*(MathAbs(open1-close1)))&&((MathAbs(high1-MathMax(open1,close1)))<=0.2*(MathAbs(close1-open1))));
// set up algo
if ((abandoned_baby==true||morning_doji_star==true||three_inside_up==true||three_outside_up==true||three_white_soldiers==true)&&open1<MA)
    {
       ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"BF",16384,0,Green);
       if(ticket>0) // if order can be filled
           {
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))// if order is executed
               Print("BUY order opened : ",OrderOpenPrice());//     then notifiy the trader that it was executed.
            }
        return(0);
     }
     return(0);
    }
  return(0);
  }
//Trailing stop
if(TrailingStop>0)
  {
   if(Bid-OrderOpenPrice()> Point*TrailingStop) // if the is a chance of lossing more than trailing stop
      {
        if(OrderStopLoss()< Bid-Point*TrailingStop) // amd if a trailing stop would work
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-Point*TrailingStop, OrderTakeProfit(),0,Orange);
         }
       }
      return(0);
     }
  return(0);
}
//----------------------------------------------------------------------------------------  
void TrailingStop() {

int Stlev;  
double Up,Dn,Sl,B_,A_;

  Stlev  = MarketInfo(Symbol(),MODE_STOPLEVEL);
  Up = NormalizeDouble(StopUp-Distance*Tick,Digits); Dn = NormalizeDouble(StopDn+Distance*Tick,Digits);  
  Sl = NormalizeDouble(Stlev*Tick,Digits);

  if(OrderType()==OP_BUY) {
    RefreshRates();
    B_ = NormalizeDouble(Bid,Digits);
    if(OrderOpenPrice()<Up && OrderStopLoss()<Up && B_-Sl>Up) {
    
    OrderModify(OrderTicket(),OrderOpenPrice(),Up,OrderTakeProfit(),0,Violet);
    return;
    }}
  
  if(OrderType()==OP_SELL) {
    RefreshRates();
    A_ = NormalizeDouble(Ask,Digits);
    if(OrderOpenPrice()>Dn && OrderStopLoss()>Dn && A_+Sl<Dn) {
      
    OrderModify(OrderTicket(),OrderOpenPrice(),Dn,OrderTakeProfit(),0,Violet);
    return;
    }}
}
//----------------------------------------------------------------------------------------  

//--------------------------------------------------------------------
void CLOSEORDER(string ord)
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()||Magic!=OrderMagicNumber()) continue;
         if (OrderType()==OP_BUY && ord=="Buy")
            OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
         if (OrderType()==OP_SELL && ord=="Sell")
            OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
      }   
   }
}
//--------------------------------------------------------------------
void OPENORDER(string ord)
{
   int error;
   if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUYSTOP, LOT,Ask+160*Point,2,SL,TP,"EMA WMA RSI",Magic,3);
   if (ord=="Sell") error=OrderSend(Symbol(),OP_SELLSTOP,LOT,Bid-100*Point,2,SL,TP,"EMA WMA RSI",Magic,3);
   if (error==-1)   ShowERROR(error,0,0);
return;
}                  
//--------------------------------------------------------------------
void ShowERROR(int Ticket,double SL,double TP)
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:                                                                               return;
      case 2:   Alert("       "              ,Ticket," ",Symbol());return;
      case 130: Alert("Error     Ticket ",                 Ticket," ",Symbol());return;
      case 134: Alert("    ",                         Ticket," ",Symbol());return;
      case 146: Alert("Error    ",             Ticket," ",Symbol());return;
      case 129: Alert("Error   ",                      Ticket," ",Symbol());return;
      case 131: Alert("Error   ",                     Ticket," ",Symbol());return;
      default:  Alert("Error  " ,err,"   Ticket ",                     Ticket," ",Symbol());return;
   }
}
//--------------------------------------------------------------------
double LOT(int risk,int ord)
{
   if (Lot!=0) return(Lot);
   double MINLOT = MarketInfo(Symbol(),MODE_MINLOT);
   LOT = AccountFreeMargin()*risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/ord;
   if (LOT>MarketInfo(Symbol(),MODE_MAXLOT)) LOT = MarketInfo(Symbol(),MODE_MAXLOT);
   if (LOT<MINLOT) LOT = MINLOT;
   if (MINLOT<0.1) LOT = NormalizeDouble(LOT,2); else LOT = NormalizeDouble(LOT,1);
   return(LOT);
}

//--------------------------------------------------------------------
double SlLastBar(int tip,double price, int tipFr, int tral)
{
   double fr;
   int jj,ii,delta=5;
   if (tral!=0)
   {
      if (tip==1) fr = Bid - tral*Point;  
      else fr = Ask + tral*Point;  
   }
   else
   {
      if (tipFr==0)
      {
         if (tip== 1)
         for (ii=1; ii<100; ii++) 
         {
            fr = iFractals(NULL,0,MODE_LOWER,ii);
            if (fr!=0) if (price-delta*Point > fr) break;
            else fr=0;
         }
         if (tip==-1)
         for (jj=1; jj<100; jj++) 
         {
            fr = iFractals(NULL,0,MODE_UPPER,jj);
            if (fr!=0) if (price+delta*Point < fr) break;
            else fr=0;
         }
      }
      else
      {
         if (tip== 1)
         for (ii=1; ii<100; ii++) 
         {
            fr = iLow(NULL,0,ii);
            if (fr!=0) if (price-delta*Point > fr) break;
            else fr=0;
         }
         if (tip==-1)
         for (jj=1; jj<100; jj++) 
         {
            fr = iHigh(NULL,0,jj);
            if (price+delta*Point < fr) break;
            else fr=0;
         }
      }
   }
/*   if (tip== 1)
   {
      ObjectDelete("SL Buy");
      ObjectDelete("SL-");
      ObjectCreate("SL Buy",OBJ_ARROW,0,TIME,fr,0,0,0,0);                     
      ObjectSet   ("SL Buy",OBJPROP_ARROWCODE,6);
      ObjectSet   ("SL Buy",OBJPROP_COLOR, Blue);
      ObjectCreate("SL-",OBJ_ARROW,0,TIME,price-delta*POINT,0,0,0,0);                     
      ObjectSet   ("SL-",OBJPROP_ARROWCODE,4);
      ObjectSet   ("SL-",OBJPROP_COLOR, Blue);
   }
   if (tip==-1)
   {
      ObjectDelete("SL Sell");
      ObjectDelete("SL+");
      ObjectCreate("SL Sell",OBJ_ARROW,0,TIME,fr,0,0,0,0);
      ObjectSet   ("SL Sell",OBJPROP_ARROWCODE,6);
      ObjectSet   ("SL Sell", OBJPROP_COLOR, Green);
      ObjectCreate("SL+",OBJ_ARROW,0,TIME,price+delta*POINT,0,0,0,0);                     
      ObjectSet   ("SL+",OBJPROP_ARROWCODE,4);
      ObjectSet   ("SL+",OBJPROP_COLOR, Green);
   }*/
   return(fr);
}
//+------------------------------------------------------------------+
